@ECHO OFF
Title "MC Backup Restore Script"
::By Dateranoth - October 14, 2010
::Feel free to change, adapt, and distribute
::Created for use restoring incremental backups created by MCBackup
::http://www.gamercide.org/forum/index.php?/topic/1407-minecraft-alpha-server-backup-utility/

::V1.0-Initial creation
:start
ECHO.
ECHO               Starting MC Backup Restore.
ECHO.
ECHO First You will be asked to select the appropriate variables.
ECHO The below variables are directories without trailing Slashes.
ECHO After proper variables are input the script will extract the 
ECHO backup to the directory you select. The Incremental backup number
ECHO you select will be the Restored date and time.
ECHO.
ECHO.
::SET _7zipdir=Uncomment this SET, Comment Out below SET and set 7zip directory here if not wanting to set it everytime.
SET /p _7zipdir="Please set the path to 7z.exe: "
ECHO.
SET /p backupdir="Please set the path to the backup directory you'd like to restore: "
ECHO.
ECHO The restore extracts the world directory as the world named folder.
ECHO ie. Setting C:\yourpath would restore to C:\yourpath\yourworldname
ECHO.
::SET extractdir=Uncomment this SET, Comment Out below SET and set extract directory here if not wanting to set it everytime
SET /p extractdir="Please set the path to the directory you would like to restore the back up to: "
ECHO.
ECHO The field entered below MUST be a number. 0 to restore only the master backup.
SET /p incrnumber="Please set the Incremental backup number you would like to restore to: "
ECHO.
ECHO.

:check1
IF EXIST "%_7zipdir%\7z.exe" (goto check2) ELSE (
ECHO.
ECHO 7z.exe cannot be found in %_7zipdir% . Please enter proper directory.
ECHO.
SET /p _7zipdir="Please set the path to 7z.exe: "
goto check1)

:check2
IF EXIST "%backupdir%\IncrMaster_*.7z" (goto allgood) ELSE (
ECHO.
ECHO IncrMaster_*.7z cannot be found in %backupdir% 
ECHO Please set the directory where the master backup file is located.
ECHO.
SET /p backupdir="Please set the path to the backup directory you'd like to restore: "
goto check2)

:allgood

ECHO %_7zipdir%  has been input as the directory 7z.exe is located
ECHO.
ECHO %backupdir% has been input as the directory containing the backup files.
ECHO.
ECHO %extractdir% has been input as the directory you wish to restore to.
ECHO.
IF %incrnumber%==0 (
ECHO You have selected to restore only the Master Backup file.
) ELSE (
ECHO You have selected to restore Backup #%incrnumber% .
)
ECHO.
ECHO If these variables are incorrect. Exit and restart batch.  Otherwise:
ECHO WARNING. IF RESTORING TO WORLD DIRECTORY. DELETE OLD WORLD DIRECTORY FILES FIRST.
pause

:start
SET incrnumbercounter=1
ECHO. Extracting Master file to %extractdir%
"%_7zipdir%\7z.exe" x "%backupdir%\IncrMaster_*.7z" -y -o"%extractdir%"

goto incrstart

:incrstart
IF %incrnumbercounter% GTR %incrnumber% (goto finished) ELSE (goto incrcheck)

:incrcheck
IF EXIST "%backupdir%\incr_#%incrnumbercounter%_*.7z" (goto incrextract) ELSE (goto ERROR)

:ERROR
ECHO Incremental backup #%incrnumbercounter% not found.  Restore will attempt to find next incremental backup file.
ECHO This may result in corrupt restoration. Press enter to search for next backup file or exit batch.
ECHO.
SET /a incrnumbercounter=incrnumbercounter+1
pause
goto incrstart

:incrextract
ECHO Extracting Incremental Backup file #%incrnumbercounter% of %incrnumber%

ECHO.
"%_7zipdir%\7z.exe" x "%backupdir%\incr_#%incrnumbercounter%_*.7z" -y -o"%extractdir%"
SET /a incrnumbercounter=incrnumbercounter+1
goto incrstart

:finished
ECHO Restoration of backup #%incrnumber% in %backupdir% completed.
ECHO.
ECHO All files restored to %extractdir%.
ECHO.
ECHO If restoring from a V2.5 backup or above you will have Server Files located in _ServerFiles directory of your restored world directory.
ECHO You will need to manually restore these to your server directory if needed.
ECHO. 

:end
pause
exit